// copyright

/**
 * This is the primary header file for the CSim car simulator.
 * This should be the only header file that should be needed
 * for the main function.
 *
 * @author Steven Bergom
 */

#ifndef _CSIM_H
#define _CSIM_H

/**
 * Include files
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <assert.h>
#include <vector.h>
#include <iostream.h>
#include <fstream.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <dlfcn.h>

#ifdef HAS_BOOL
#include <bool.h>
#endif

typedef vector< double > double_vector;

#include "conf.h"
#include "csim_endcond.h"
#include "csim_mmanager.h"
#include "csim_model.h"
#include "csim_graph.h"
#include "csim_rand.h"
#include "csim_conf.h"

/**
 * External definitions
 */
extern Configuration main_config;

struct _OutputFuncs
{
  void (*init_output)(void);
  void (*close_output)(void);
  void (*path_output)(const vector< GraphNode* > &path);
  void (*segment_output)(GraphNode &gn1, GraphNode &gn2);
};

typedef _OutputFuncs OutputFuncs;

#endif // _CSIM_H
