#include "triplevec.h"
#include <iostream.h>
#include <vector.h>

#ifndef _POLYGON_H
#define _POLYGON_H

//**********************************************//
// MACROS                                       //
//**********************************************//
#define MAX_VERTICES 20
#define MAX(A,B)  (A>B)?A:B
#define MIN(A,B)  (A<B)?A:B

//
// Polygon
//
class Polygon {
public:
  Polygon() { numVerts = 0; };
  Polygon(const Polygon &p);
  Polygon(Point *verts, int vertCount);
  virtual ~Polygon() {};
  virtual void describe(ostream &os, bool filled=true);
  virtual void addVert(const Point &v);
  virtual void setNumVerts(int a) {};
  virtual bool intersect(const Point &v);
  virtual bool intersect(Polygon *p);
  virtual Polygon *transform(vector< double > trans);

protected:
  Point vertices[MAX_VERTICES];
  int numVerts;
  Point P;
  double D;
};

#endif // _POLYGON_H
