#include <iostream.h>

#ifndef _TRIPLEVEC_H
#define _TRIPLEVEC_H

class Point {
public:
  Point() { v1 = v2 = 0 ; }
  Point(const Point &v);
  Point(double a, double b);
  ~Point() {}

  // Assignment operators
  Point& operator= (const Point &a);
  Point& operator+=(const Point &a);
  Point& operator-=(const Point &a);
  Point& operator*=(const double d);
  void   set(double s1, double s2) { v1 = s1; v2 = s2; }

  double operator[](int a) const;

  // Unary operators
  friend Point operator-(const Point &a);

  // Friend operators
  friend Point operator+(const Point &a, const Point &b);
  friend Point operator-(const Point &a, const Point &b);
  friend Point operator*(const Point &a, const double &d);
  friend Point operator*(const Point &a, const Point &b);
  friend Point operator*(const double d, const Point &a);
  friend Point operator/(const Point &a, const double d);

  // Test
  friend bool operator==(const Point &a, const Point &b);
  friend bool operator< (const Point &a, const Point &b);
  friend bool operator> (const Point &a, const Point &b);
  friend bool operator!=(const Point &a, const Point &b);
  friend ostream& operator<<(ostream &out, const Point &a);

  // Geometric operators
  double Magnitude() const;
  Point normalize() const;

protected:
  double v1, v2;
};

#endif // _TRIPLEVEC_H
