#include "csim.h"

double SQR(double d1)
{
  return d1*d1;
}

GraphNode::GraphNode()
{
}

GraphNode::GraphNode(const GraphNode &gn)
{
  parent = gn.parent;
  graph_id = gn.graph_id;
  for (int i=0; i<gn.data.size(); i++)
  {
    data.push_back(gn.data[i]);
  }
}

GraphNode::GraphNode(const double_vector &dv)
{
  for (int i=0; i<dv.size(); i++)
  {
    data.push_back(dv[i]);
  }
}

GraphNode::~GraphNode()
{
}

void GraphNode::setData(const double_vector &dv)
{
  for (int i=0; i<dv.size(); i++)
  {
    data.push_back(dv[i]);
  }
}

double_vector GraphNode::getData()
{
  return data;
}

unsigned long GraphNode::getSize()
{
  return (unsigned long)data.size();
}

unsigned long GraphNode::getParent()
{
  return parent;
}

void GraphNode::setParent(GraphNode &gn)
{
  parent = gn.graph_id;
}

ostream& operator<<(ostream &out, const GraphNode &gn)
{
  out << "{ ";

  out << "id " << gn.graph_id << " ";
  out << "parent " << gn.parent << " ";

  for (int i=0; i<gn.data.size(); i++)
  {
    out << gn.data[i] << " ";
  }

  out << "}";

  return out;
}

Graph::Graph(GraphNode &gn)
{
  current_end = 0;
  gn.graph_id = 0;
  gn.parent   = (unsigned long)0xFFFFFFFF;
  children.push_back(GraphNode(gn));
}

Graph::~Graph()
{
}

void Graph::insert(GraphNode _parent, GraphNode child)
{
  current_end++;
  child.graph_id = current_end;
  child.setParent(_parent);
  children.push_back(child);
}

vector<GraphNode*> Graph::getNodeLine(const GraphNode &gn)
{
  unsigned long next_id = gn.graph_id;
  vector< GraphNode* > ret_val;

  while (children[next_id].parent != 0xFFFFFFFF)
  {
    ret_val.push_back(&children[next_id]);
    next_id = children[next_id].parent;
  }

  return ret_val;
}

ostream& operator<<(ostream &out, Graph &g)
{
  for (unsigned long i=1; i<=g.current_end; i++)
  {
    out << g.children[i] << endl;
  }
  return out;
}

