#include "csim.h"

#define ADJUST(x)  x*500+100

void psOutput(GraphNode &gn1, GraphNode &gn2);
void psFinal(const vector< GraphNode* > &path);
void psBegin(void);
void psEnd(void);

OutputFuncs output = {
  psBegin,
  psEnd,
  psFinal,
  psOutput
};


void allStuff(ofstream &out)
{
  (out) << "0.9 0.9 0.9 setrgbcolor\n";
  (out) << ADJUST(-0.1) << " " << ADJUST(-0.1) << " moveto\n";
  (out) << ADJUST(-0.1) << " " << ADJUST(1.1) << " lineto\n";
  (out) << ADJUST(1.1) << " " << ADJUST(1.1) << " lineto\n";
  (out) << ADJUST(1.1) << " " << ADJUST(-0.1) << " lineto\n";
  (out) << "closepath\n fill\n" << flush;
  main_config.environment->describe((out));
  (out) << "0 0 0 setrgbcolor\n";
}

void psOutput(GraphNode &gn1, GraphNode &gn2)
{
  
  double_vector first, second;

  first = gn1.getData();
  second = gn2.getData();

  (*main_config.out) << ADJUST(first[0]) << " " 
		     << ADJUST(first[1]) << " moveto ";
  (*main_config.out) << ADJUST(second[0]) << " " 
		     << ADJUST(second[1]) << " lineto ";
  (*main_config.out) << " stroke\n" << flush;
  
}

void psFinal(const vector< GraphNode* > &path)
{
  /*
  int path_size = path.size();
  double_vector data;
  (*main_config.out) << " 2 setlinewidth 1 0 0 setrgbcolor\n";

  data = path[0]->getData();
  (*main_config.out) << ADJUST(data[0]) << " " 
		     << ADJUST(data[1]) << " moveto ";

  for (int i=1; i<path_size; i++)
  {
    double diff = i/(double)path_size;
    (*main_config.out) << (1-diff) << " " << diff << " 0 setrgbcolor\n";
    data = path[i]->getData();
    (*main_config.out) << ADJUST(data[0]) << " " 
		       << ADJUST(data[1]) << " lineto " << flush;
    (*main_config.out) << " stroke\n" << flush;
    (*main_config.out) << ADJUST(data[0]) << " " 
		       << ADJUST(data[1]) << " moveto " << flush;
  }
  */

  Polygon *p;
  Polygon *rbt;
  int path_size = path.size();
  double_vector data;

  rbt = main_config.environment->getRobot();

  for (int i=path_size-1; i>=0; i--)
  {
    ofstream outfile;
    char buf[8];
    sprintf(buf, "%.4i.ps", (path_size-i));
    outfile.open(buf);
    allStuff(outfile);
    data = path[i]->getData();
    p = rbt->transform(data);
    p->describe(outfile, false);
    (outfile) << " stroke" << endl;
    delete p;
    outfile << "showpage\n quit" << endl << flush;
    outfile.close();
  }
}

void psBegin()
{
  (*main_config.out) << "%!PS-Adobe-2.0\n";
  //allStuff((ofstream)*main_config.out);
  (*main_config.out) << "0.9 0.9 0.9 setrgbcolor\n";
  (*main_config.out) << ADJUST(-0.1) << " " << ADJUST(-0.1) << " moveto\n";
  (*main_config.out) << ADJUST(-0.1) << " " << ADJUST(1.1) << " lineto\n";
  (*main_config.out) << ADJUST(1.1) << " " << ADJUST(1.1) << " lineto\n";
  (*main_config.out) << ADJUST(1.1) << " " << ADJUST(-0.1) << " lineto\n";
  (*main_config.out) << "closepath\n fill\n" << flush;
  main_config.environment->describe((*main_config.out));
  (*main_config.out) << "0 0 0 setrgbcolor\n";
  //(*main_config.out) << "0.9 0.9 0.9 setrgbcolor\n";
  //(*main_config.out) << ADJUST(0) << " " << ADJUST(0) << " moveto\n";
  //(*main_config.out) << ADJUST(0) << " " << ADJUST(1) << " lineto\n";
  //(*main_config.out) << ADJUST(1) << " " << ADJUST(1) << " lineto\n";
  //(*main_config.out) << ADJUST(1) << " " << ADJUST(0) << " lineto\n";
  //(*main_config.out) << "closepath\n fill\n" << flush;
  main_config.environment->describe((*main_config.out));
  (*main_config.out) << "0 0 0 setrgbcolor\n";
}

void psEnd()
{
  (*main_config.out) << "showpage\n quit" << endl << flush;
}

